import os
import json
import pygame
from . import engine

data_py = os.path.abspath(os.path.dirname(__file__))
data_dir = os.path.normpath(os.path.join(data_py, '..', 'data'))

def filepath(filename):
    return os.path.join(data_dir, filename)

def load(filename, mode='rb'):
    return open(os.path.join(data_dir, filename), mode)

def read_json(filename):
	file = load(filename, 'r')
	jsonstring = file.read()
	file.close()
	jsondata = json.loads(jsonstring)
	return jsondata

def load_image(filename):
	UNIT = engine.UNIT
	TEXUNIT = engine.TEXUNIT
	image = pygame.image.load(load(filename), filename).convert_alpha()
	w,h = image.get_size()
	image = pygame.transform.scale(image, (int(w/TEXUNIT*UNIT), int(h/TEXUNIT*UNIT))).convert_alpha()
	return image
