class Particle:
	def __init__(self, pos, vel, colors, life):
		self.pos = pos
		self.vel = vel
		self.colors = colors
		self.life = life
		self.timer = 0.0

	def update(self, delta):
		self.pos.x += self.vel.x*delta
		self.pos.y += self.vel.y*delta
		self.vel.y -= 9.8*delta
		self.timer += delta

	def get_color(self):
		ccount = len(self.colors)
		t = min(1.0, self.timer/self.life)
		cid = int(t*ccount)
		if cid == ccount:
			cid -= 1
		return self.colors[cid]

	def is_finished(self):
		return self.timer >= self.life
