import pygame
from .data import load

SOUNDS = {}

panic_ambience = None
panic_channel = None
panic_timer = 0.0

generator_noise_channel = None
battle_noise_channel = None
screamer_channel = None

generator_noise_0 = None
generator_noise_1 = None

def initialize():
	global panic_ambience, panic_channel, generator_noise_0, generator_noise_1
	global generator_noise_channel, battle_noise_channel, screamer_channel

	panic_channel = pygame.mixer.Channel(1)
	generator_noise_channel = pygame.mixer.Channel(2)
	panic_ambience = load_sound('snd/panic.ogg', 'panic')
	battle_noise = load_sound('snd/battle.ogg', 'battle')

	battle_noise_channel = pygame.mixer.Channel(3)
	battle_noise_channel.play(battle_noise, -1)
	battle_noise_channel.pause()

	panic_channel.set_volume(0.0)
	panic_channel.play(panic_ambience, -1)

	screamer_channel = pygame.mixer.Channel(4)

	generator_noise_0 = load_sound('snd/generator_noise_0.ogg', 'generator_noise_0')
	generator_noise_1 = load_sound('snd/generator_noise_1.ogg', 'generator_noise_1')

noise_level = 0

def set_battle(flag):
	if flag:
		battle_noise_channel.unpause()
	else:
		battle_noise_channel.pause()

def set_generator_noise(level):
	global noise_level
	#if noise_level == level:
	#	return
	noise_level = level
	if level == 0:
		generator_noise_channel.pause()
	elif level == 1:
		generator_noise_channel.play(generator_noise_0, -1)
	else:
		generator_noise_channel.play(generator_noise_1, -1)

def add_panic(value):
	global panic_timer
	if panic_timer <= 0.0:
		panic_channel.unpause()
	panic_timer += value

def update(delta, panic):
	global panic_timer
	if panic:
		if panic_timer == 0.0:
			panic_channel.unpause()
		panic_timer += delta*0.12
	else:
		panic_timer -= delta*0.2
		if panic_timer < 0.0:
			panic_timer = 0.0
			panic_channel.pause()
	panic_channel.set_volume(max(0.0, panic_timer))

def load_sound(filename, shortname):
	sound = pygame.mixer.Sound(load(filename))
	SOUNDS[shortname] = sound
	return sound

def play(soundname, important=False):
	sound = SOUNDS[soundname]
	if important:
		screamer_channel.play(sound)
	else:
		sound.play()
